/* FOR COMPILATION AND DEBUGGING PURPOSES ONLY! */
/* This as.h file contains stubs for all AS routines used by the universe. */

#include "as.h"
#include "fe.h"
#include "untypes.h"
#include <stdio.h>                      /* NULL. */
#include <mem.h>						/* memset */
#include <stdlib.h>

/*****************************
 * Function Definitions
 ****************************/

void AS_InitializePic(UN_Object *obj)
{
	if (!obj->pic)
	{
	    obj->pic = (AS_Picture *) FE_Malloc(sizeof(AS_Picture));
		((AS_Picture *)obj->pic)->curpic = NULL;
		((AS_Picture *)obj->pic)->thrustpic = NULL;
		((AS_Picture *)obj->pic)->brakepic = NULL;
		((AS_Picture *)obj->pic)->targetpic = NULL;
	}
}

void AS_SetPic(AS_Picture *pic, long type)
{
    if (type & THRUSTPIC) {
	pic->curpic = pic->thrustpic;
    } else
    if (type & BRAKEPIC) {
	pic->curpic = pic->brakepic;
    }
    if (type & TARGETPIC) {
	pic->curpic = pic->targetpic;
    }
}

void AS_PlayFX(long type) 
{
    switch (type) {
	case FX_DIE:
	    break;
    }
}

void AS_ShowMovie(AS_MovieNum number)
{
    switch (number) {
	case GAME_OVER:
	    printf("Player died.\n");
	    break;
	case PLAYER_WON:
	    printf("Player won.\n");
	    break;
	case INTRO:
	case INSTRUCTIONS:
	case CREDITS:
	case OUTRO:
	case WAVE_BASE:
	default:
	    printf("Playing movie %i\n",number);
	    break;
    }
}

void AS_GeneratePic(UN_Object *obj)
{
    AS_Picture *pNewPic;
	char *newdata;
	FILE *file;

	if( !obj->pic )
		AS_InitializePic(obj);

	pNewPic = (AS_Picture *)obj->pic;

	/* Temporary: create empty picture of random value... */
	newdata = (char *) FE_Malloc( 128*128 );
	memset(newdata, 5, 128*128);
	file = fopen("ship.var", "rb");
	if (!file)
	{
/* This is commented out as for some reason this fails under my
 * debugger... */
#if 0
		FE_DisplayError(E_INITSYS);
		exit(-1);
#endif
	}
	else
	{
		fread(newdata, 1, 32*32, file);
		fclose(file);
	}

	pNewPic->thrustpic = FE_CompileSprite(newdata);
	FE_Free(newdata);
	pNewPic->curpic = pNewPic->thrustpic;
	pNewPic->targetpic = pNewPic->thrustpic;
	pNewPic->brakepic = pNewPic->thrustpic;
}
