/* FOR COMPILATION AND DEBUGGING PURPOSES ONLY! */
/* This as.h file contains headers for all AS routines used by the universe.
 * This can be taken as a definition of the current AS/UN API. */

#ifndef ARTSOUND_H_
#define ARTSOUND_H_

#include "untypes.h"

/* Description:
 * Type values for PlayFX (typedef anyone?)
*/

enum {
    FX_DIE=1,
};


/* Description:
*/
typedef unsigned short AS_MovieNum;
enum {
   INTRO=0,
   INSTRUCTIONS,
   CREDITS,
   OUTRO,
   GAME_OVER,
   PLAYER_WON,
   WAVE_BASE
/* This should be the last entry, as the "current wave's movie" is
 * (WAVE_BASE + current_wave_number), where the waves start at 0. */
};


/*****************************
 * Picture Struct
 ****************************/

/*
 * AS_Picture:
 * 
 * temp                      - nothing
 *            how should the sprite ptrs be stored? We need ptrs to the
 *            overlays e.g. THRUST etc as well as the current frame
*/
typedef struct AS_Picture_s {
	char *curpic;           /* Current picture to be displayed */
	/* Add here some data structure describing other possible pics. */
	/* Temporary: */
	char *thrustpic;
	char *brakepic;
	char *targetpic;
} AS_Picture;

#define THRUSTPIC (NUM_DIRS)
#define BRAKEPIC (NUM_DIRS*2)
#define TARGETPIC (NUM_DIRS*4)

/*****************************
 * Function Prototypes
 ****************************/

void AS_InitializePic(UN_Object *obj);

void AS_SetPic(AS_Picture *pic, long type);

void AS_PlayFX(long type);

void AS_ShowMovie(AS_MovieNum number);

void AS_GeneratePic(UN_Object *obj);

#endif
