;
; JOYSTICK
;		Joystick handler routines
; Joystructure is 4 ints for buttons, then 4 ints for axes.  See header.
;

		.486p

;
; Functions:
;
public JOYSTICK_GetStatus_			; off of joy struct
public JOYSTICK_SetMax_				; int new max

;
; EQUATES
;

GAMEPORT = 201h

;
; DATA
;
_DATA segment para public use32 'DATA'

RealModeRegs:
v86_edi DD ?
v86_esi DD ?
v86_ebp DD ?
v86_rsrvd DD ?
v86_ebx DD ?
v86_edx DD ?
v86_ecx DD ?
v86_eax DD ?
v86_flags DW ?
v86_es DW ?
v86_ds DW ?
v86_fs DW ?
v86_gs DW ?
v86_ip DW ?
v86_cs DW ?
v86_sp DW ?
v86_ss DW ?

jrange DD 4000
jdelay DD 1

ends _DATA

;
; CODE
;
_TEXT segment para public use32 'CODE'
		assume cs:_TEXT, ds:_DATA, es:_DATA

;
; FUNCTIONS
;

;
; JOYSTICK_SetMax
;	v JOYSTICK_SetMax(int max);
;						eax
;
JOYSTICK_SetMax_ proc
	mov jrange, eax
	ret
JOYSTICK_SetMax_ endp


;
; JOYSTICK_GetStatus
;	v JOYSTICK_GetStatus(JOY *data);
;							eax
;
JOYSTICK_GetStatus_ proc
	push ebx ecx edx edi esi es
	mov esi, eax			; Joy struct.

	; Other vesrion:
	mov DWORD PTR [esi+16], 0
	mov DWORD PTR [esi+20], 0
	mov DWORD PTR [esi+24], 0
	mov DWORD PTR [esi+28], 0			; Initialize
	mov ecx, jrange
	mov edx, GAMEPORT
	out dx, al							; Start
	Loop75:
		mov ebx, jdelay
		Loop77:
			in al, dx
			dec ebx
			jnz Loop77
		shr al, 1
		adc [esi+16], ebx
		shr al, 1
		adc [esi+20], ebx
		shr al, 1
		adc [esi+24], ebx
		shr al, 1
		adc [esi+28], ebx
		dec ecx
		jnz Loop75
;	not al				; Invert buttons
	; Store buttons:
	shl eax, 29
	setc cl
	mov [esi+12], ecx
	add eax, eax
	setc cl
	mov [esi+8], ecx
	add eax, eax
	setc cl
	mov [esi+4], ecx
	add eax, eax
	setc cl
	mov [esi], ecx


	; Done:
	pop es esi edi edx ecx ebx
	ret
JOYSTICK_GetStatus_ endp

ends _TEXT
end

