;
; KEYHNDLR:
;		The keyboard handler routines.
;

        .486p

;
; Functions:
;
public KEYHNDLR_Install_			; off of 256 byte keytable
public KEYHNDLR_Remove_
public KEYHNDLR_Enable_


;
; DATA
;
_DATA segment para public use32 'DATA'

keytable DD ?
OldKeyOff DD ?
OldKeySeg DW ?
KeyRecEnable DW ?

ends _DATA

;
; CODE
;

_TEXT segment para public use32 'CODE'
		assume cs:_TEXT, ds:_DATA, es:_DATA

;
; FUNCTIONS
;

;
; KEYHNDLR_Install
;    v KEYHNDLR_Install(char *keytab);
;							EAX
;
KEYHNDLR_Install_ proc
	mov keytable, eax
	mov KeyRecEnable, 1	; Start recording...
; Hook vectors:
	push esi edi ebx ecx es
	mov eax, 3515h
	int 21h					; get old int into es:bx
	mov OldKeySeg, es
	mov OldKeyOff, ebx
	pop es
	mov edi, keytable
	xor eax, eax
	mov ecx, 64
	rep stosd				; Clear interrup table.
	mov eax, 2515h
	mov edx, offset int15
	push ds cs
	pop ds
	int 21h					; Set the vector.
	pop ds
; Save the DS so anyone can get it:
	push eax ebx ecx es
	xor ebx, ebx
	mov bx, cs
	mov eax, 0ah		; Create Alias.
	int 31h
	; Should jump off on error (CF set)
	mov bx, ds
	mov es, ax
	mov ecx, offset OurDS
	mov es:[ecx], bx
	mov ecx, offset OurCSKeySeg
	mov bx, OldKeySeg
	mov es:[ecx], bx
	mov ebx, OldKeyOff
	mov ecx, offset OurCSKeyOff
	mov es:[ecx], ebx
	pop es
	; Free selector:
	mov ebx, eax
	mov eax, 1
	int 31h
	; Again, check error code.
	pop ecx ebx eax
	pop ecx ebx edi esi
	ret
KEYHNDLR_Install_ endp

;
; KEYHNDLR_Remove
;	v KEYHNDLR_Remove();
;
KEYHNDLR_Remove_ proc
	push eax edx ecx ebx es ds
	mov edx, OldKeyOff
	mov ds, OldKeySeg
	mov eax, 2515h
	int 21h					; reset int handler.
	pop ds es ebx ecx edx eax
	ret
KEYHNDLR_Remove_ endp

;
; KEYHNDLR_Enable
;	v KEYHNDLR_Enable(int enable?);
;
KEYHNDLR_Enable_ proc
	mov KeyRecEnable, ax
	ret
KEYHNDLR_Enable_ endp

; Ugly, but works:
OurDS DW ?
OurCSKeyOff DD ?
OurCSKeySeg DW ?

;*********************************************************************
; Interrupt handlers:  Pretty self evident.
;*********************************************************************
int15 proc
	cmp ah, 4fh
	jz Skip195
		; Chain...
		jmp FWORD PTR cs:[OurCSKeyOff]
Skip195:
	push eax ebx ds
; Get data segment:
	mov bx, cs:OurDS
	mov ds, bx
	cmp KeyRecEnable, 0
	jz EndTest133
; DEBUG:
;	mov ebx, 0b0000h
;	inc BYTE PTR [ebx]
;	mov BYTE PTR [ebx+2], al
; END DEBUG
	xor ebx, ebx
	mov bl, al		; Save scan code.
	test bl, 80h	; Is it release?
	jnz ZeroCharacter
		add ebx, keytable
		mov BYTE PTR [ebx], 1		; Char is pressed.
		mov BYTE PTR [ebx+128], 1	; Set sticky key table...
		jmp Skip143
	ZeroCharacter:
		and bl, 7fh
		add ebx, keytable
		mov BYTE PTR [ebx], 0
	Skip143:

	pop ds ebx eax
	mov al, 80h				; Fake new scan code... (Release Esc.)
	jmp FWORD PTR cs:[OurCSKeyOff]


EndTest133:					; We've decided not to record.
	pop ds ebx eax
	jmp FWORD PTR cs:[OurCSKeyOff]
;	iretd
int15 endp

ends _TEXT
end						
