/***************************************************************************\
* Alife Game - main.h header file                                           *
* ------------------------------------------------------------------------- *
* Copyright (C) 1995 - 1997 Project Von Neumann Team.  All Rights Reserved. *
* ------------------------------------------------------------------------- *
* Last Revised: 1/1/97                                                      *
* By:           Adrian Tymes                                                *
* Version #:    0.80                                                        *
* Note:         What the program does when not playing a game.              *
\***************************************************************************/

#ifndef MAIN_H_
#define MAIN_H_

/* Description:
 * A universe-and-main internal variable with the current movie (starting at
 * 0
 0 when
 * not in a game, otherwise equal to the current level, or GAME_WON
 * (= last level + 1) if the player's just won the game). */

extern short curmovie;

/* Description:
 * Struct to hold a button since FE will probably need these to draw the
 * MAINMENU etc */

typedef struct MA_Button_s {
    unsigned long ulx,uly,lrx,lry;
} MA_Button;


/* Description:
 * Declarations of all the buttons. Used by FE_DisplayScreen to draw them
*/

extern MA_Button
    NEW_btn,  REP_btn,  LOAD_btn,
    CONT_btn, INST_btn, SAVE_btn,
    OPT_btn,  CRED_btn, QUIT_btn,
    YES_btn,            NO_btn;

#endif
