;
; TIMER:
;		The keyboard handler routines.
;

        .486p

;
; Functions:
;
public TIMER_Install_			; off of integer time func
public TIMER_SetRate_			; int, magic value
public TIMER_Remove_


;
; DATA
;
_DATA segment para public use32 'DATA'

tickoff DD ?
OldTimerOff DD ?
OldTimerSeg DW ?
refreshrate DD 1
refreshstep DD 1		; Default to normal speed.

ends _DATA

;
; CODE
;

_TEXT segment para public use32 'CODE'
		assume cs:_TEXT, ds:_DATA, es:_DATA

;
; FUNCTIONS
;

;
; TIMER_Install
;    v TIMER_Install(int *tick);
;							EAX
;
TIMER_Install_ proc
	mov tickoff, eax
; Hook vectors:
	push esi edi ebx ecx es
	mov eax, 3508h
	int 21h					; get old int into es:bx
	mov OldTimerSeg, es
	mov OldTimerOff, ebx
	pop es
	mov eax, 2508h
	mov edx, offset int8
	push ds cs
	pop ds
	int 21h					; Set the vector.
	pop ds
; Save the DS so anyone can get it:
	push eax ebx ecx es
	xor ebx, ebx
	mov bx, cs
	mov eax, 0ah		; Create Alias.
	int 31h
	; Should jump off on error (CF set)
	mov bx, ds
	mov es, ax
	mov ecx, offset OurDS
	mov es:[ecx], bx
	mov ecx, offset OurCSTimerSeg
	mov bx, OldTimerSeg
	mov es:[ecx], bx
	mov ebx, OldTimerOff
	mov ecx, offset OurCSTimerOff
	mov es:[ecx], ebx
	pop es
	; Free selector:
	mov ebx, eax
	mov eax, 1
	int 31h
	; Again, check error code.
	pop ecx ebx eax
	pop ecx ebx edi esi
	ret
TIMER_Install_ endp

;
; TIMER_Remove
;	v TIMER_Remove();
;
TIMER_Remove_ proc
	push eax edx ecx ebx es ds
	mov edx, OldTimerOff
	mov ds, OldTimerSeg
	mov eax, 2508h
	int 21h					; reset int handler.
	pop ds es ebx ecx edx eax
	ret
TIMER_Remove_ endp

;
; TIMER_SetRate
;  v TIMER_SetRate(int mult);
;					eax
;
TIMER_SetRate_ proc
	push edx ebx
	mov refreshstep, eax
	mov ebx, eax
	mov eax, 10000h
	xor edx, edx
	div ebx
	mov edx, eax

	cli
	mov al, 34h
	out 43h, al
	mov al, dl
	out 40h, al
	mov al, dh
	out 40h, al
	sti
	pop ebx edx
	ret

	in al, 21h
	mov bl, al			; prev int mask

	cli
	mov al, 0ffh
	out 21h, al			; Kill ints
	sti

;	mov al, 00110100b	; sample rate
;	mov al, 00110110b	; sample rate
	mov al, 34h
	out 43h, al
	mov al, dl
;	mov al, 1eh
	out 40h, al
	mov al, dh
;	mov al, 05
	out 40h, al

;	mov al, 10010000b
;	out 43h, al
;	in al, 61h
;	or al, 00000011b
;	out 61h, al

	cli					; REstore ints.
	mov al, bl
	out 21h, al
	sti
	pop ebx edx
	ret
TIMER_SetRate_ endp

; Ugly, but works:
OurDS DW ?
OurCSTimerOff DD ?
OurCSTimerSeg DW ?

;
; Interrupt handlers:  Pretty self evident.
;
int8 proc
	push eax ds
	mov ax, cs:OurDS
	mov ds, ax
	mov eax, tickoff
	inc DWORD PTR [eax]
	dec refreshrate
 	jnz Skip119
		; Chain normally:
		mov eax, refreshstep
		mov refreshrate, eax
		pop ds eax
		; Chain...
		jmp FWORD PTR cs:[OurCSTimerOff]
Skip119:
	; Do proper epilogue:
	mov al, 20h
	out 20h, al
	pop ds eax
;	sti
	iretd
int8 endp

ends _TEXT
end						
