/***************************************************************************\
* Project Von Neumann - ungame.h header file                                *
* --------------------------------------------------------------------------*
* Copyright (C) 1995 - 1997 Project Von Neumann Team.  All Rights Reserved. *
* --------------------------------------------------------------------------*
* Last Revised: 4/12/97                                                     *
* By          : Adrian Tymes                                                *
* Version #   : 0.81                                                        *
* Description : The game physics functions and main loop                    *
\***************************************************************************/ 

#ifndef UNGAME_H
#define UNGAME_H

/* include types */
#include "untypes.h"

/***************************************************************************\
* Description: Global variables
\***************************************************************************/

extern UN_Object* Player; /* pointer to the player object */
/* dynamically allocated 2-d array of ptrs to obj lists */
extern UN_Object* **Sectors;
extern UN_Object* ActiveObjects;

extern float UN_Sin[NUM_DIRS];
extern float UN_Cos[NUM_DIRS];

extern long ThrustCost[MAX_THRUST];

extern UN_Coord size_x, size_y;
extern unsigned long size_sectx, size_secty;
extern unsigned short shifts_sectx, shifts_secty;

/***************************************************************************\
* Description: Function Prototypes
\***************************************************************************/

short UN_GameLoop();

#endif
