/***************************************************************************\
* Project Von Neumann - unutil.h header file                                *
* --------------------------------------------------------------------------*
* Copyright (C) 1995 - 1997 Project Von Neumann Team.  All Rights Reserved. *
* --------------------------------------------------------------------------*
* Last Revised: 4/8/97                                                      *
* By          : Adrian Tymes                                                *
* Version #   : 0.81                                                        *
* Description : Utility functions used by universe                          *
\***************************************************************************/

#ifndef UNUTIL_H
#define UNUTIL_H

/* include types */
#include "untypes.h"
#include "unal.h"

/***************************************************************************\
* Description: Function Prototypes
\***************************************************************************/

UN_Object* UN_NewObject();
void UN_DeleteObject(UN_Object* object);
void UN_ToSector(UN_Object* object);
void UN_ShiftObject(UN_Object* object);
void UN_ActivateObject(UN_Object* object);
void UN_DeActivateObject(UN_Object* object);

UN_Direction UN_AntiTanVel(UN_Velocity x, UN_Velocity y);

void UN_NewPlayer();
void UN_KillObject(UN_Object *object);

#endif
